import java.net.*;
import java.io.*;
import java.util.*;

public class Altavista extends Thread
{
    static String mot;
    static Hashtable taburl, tabMot, tabindurl;
    static PrintWriter s;
    static int nbreurl;
    public Altavista(String m, Hashtable TU, Hashtable TM, Hashtable TI)
    {
        mot = m;
        taburl = TU;
        tabMot = TM;
        tabindurl = TI;
        try
        {
            s =new PrintWriter(new BufferedWriter(new FileWriter("Base_de_donnee/Altavista.dat")));
        }
        catch(IOException IO)
        {
            System.out.println("erreur d'ouverture du fichier");
        }
    }
    
    public static synchronized void Table(String url)
    {
        URL adresse;
        try
        {
            adresse = new URL(url);
            Integer n = (Integer)taburl.get(adresse);
            if (n == null)
            {
                taburl.put(adresse, new Integer(nbreurl++));
                tabindurl.put((tabindurl.size()+""), url);
                System.out.println("Altavista new: "+url);
                s.println(url);
            }
            else System.out.println("Altavista old: "+url);
        }
        catch(MalformedURLException m)
        {
            System.out.println("Erreur URL sur Altavista: "+url);
        }
    }
    
    public void run()
    { 
        BufferedReader in;
        try
        {
            URL url = new URL("http://www.altavista.com/web/results?itag=ody&q="+mot+"&kgs=1&kls=0");
            try
            {
                in = new BufferedReader(new InputStreamReader(url.openStream()));
                String ligne;
                int l=1;
                while ((ligne = in.readLine()) != null)
                {
                    String http="",sep="<span class=ngrn>";
                    boolean ok = false;
                    int p = ligne.length(),cpt=0, Ls=sep.length();
                    while (cpt<p-Ls && !ok)
                        if(!ligne.substring(cpt,cpt+Ls).equals(sep))
                        {
                            cpt++;
                        }
                        else 
                        {
                            //System.out.println("1" + ligne);
                            cpt=cpt+Ls;
                            ok = true; 
                        }  
                    while( ok && cpt<p && ligne.charAt(cpt)!='<')
                        {
                            http=http + ligne.charAt(cpt);
                            cpt++;
                        }
                    if(ok)
                    {
                        Table("http://"+http);
                    }
                }
                in.close();
            }
            catch(IOException IO)
            {
                System.out.println("Ouverture page impossible");
            }
            
        }
        catch(MalformedURLException m)
        {
            System.out.print("Adresse URL incorrect");
        }
        s.close();
    }
}
