import java.net.*;
import java.io.*;
import java.util.*;

public class Aol extends Thread
{
    static String mot;
    static Hashtable taburl, tabMot, tabindurl;
    static PrintWriter s;
    static int nbreurl;
    
    public Aol(String m, Hashtable TU, Hashtable TM, Hashtable TI)
    {
        mot = m;
        taburl = TU;
        tabMot = TM;
        tabindurl = TI;
        try
        {
            s =new PrintWriter(new BufferedWriter(new FileWriter("Base_de_donnee/Aol.dat")));
        }
        catch(IOException IO)
        {
            System.out.println("erreur d'ouverture du fichier");
        }
    }
    
    public static synchronized void Table(String url)
    {
        URL adresse;
        try
        {
            adresse = new URL(url);
            Integer n = (Integer)taburl.get(adresse);
            if (n == null)
            {
                taburl.put(adresse, new Integer(nbreurl++));
                tabindurl.put((tabindurl.size()+""), url);
                System.out.println("Aol new      : "+url);
                s.println(url);
            }
            else System.out.println("Aol old      : "+url);
        }
        catch(MalformedURLException m)
        {
            System.out.println("Erreur URL sur Aol: "+url);
        }
    }
    
    public void run()
    {
        URL url;
        try
        {
            url = new URL("http://search.aol.com/aolcom/search?invocationType=topsearchbox.webhome&query="+mot);
            BufferedReader in;
            try
            {
                in = new BufferedReader(new InputStreamReader(url.openStream()));
                String ligne;
                int l=1;
                while ((ligne = in.readLine()) != null)
                {
                    String http="",sep="<cite>";
                    l=ligne.length();
                    if(l>15 && ligne.substring(0,6).equals(sep))
                    {
                        int cpt=6;
                        while(ligne.charAt(cpt) != '<')
                            http = http + ligne.charAt(cpt++);
                        Table(http);
                    }
                }
            in.close();
            }
            catch(IOException IO)
            {
                System.out.println("Ouverture page impossible");
            }
        }
        catch(MalformedURLException m)
        {
            System.out.print("Adresse URL incorrect");
        }
        s.close();
    }
}
