import java.net.*;
import java.io.*;
import java.util.*;

public class GestionPage extends Thread
{
    static Hashtable tabMot;
    static int nurl, nbreMot;
    static URL url;
    static String site;
    
    public GestionPage(int n, URL u, Hashtable TM, String s)
    {
        tabMot = TM;
        nurl = n;
        url = u;
        site = s;
    }
    
    public void run()
    {
        BufferedReader in;
        try
        {
            in = new BufferedReader(new InputStreamReader(url.openStream()));
            String ligne;
            boolean script=false;
            while ((ligne = in.readLine()) != null)
            {
                if( !script && ligne.length()>7 && !(script=ligne.substring(0,7).equals("<script")))
                {
                    boolean ok=false;
                    int croche=0;
                    String texte="";
                    for(int i=0;i<ligne.length();i++)
                    {
                        if(croche==0)
                        {
                            if(ligne.charAt(i)!='<')
                            {
                                ok=true;
                                texte=texte+ligne.charAt(i);
                            }
                            else croche++;
                        }
                        else
                        {
                            if(ligne.charAt(i)=='<')
                                croche++;
                            else
                                if(ligne.charAt(i)=='>')
                                    croche--;
                        }
                    }
                    if (ok)
                    {
                        getMotsURL(texte);
                    }
                }
                else
                {
                    if(ligne.equals("</script>"))
                        script=false;
                }
            }
            in.close();
        }
        catch(IOException IO)
        {
            System.out.println("Erreur d'ouverture de la page " + site);
        }
        System.out.println(nbreMot+ " nouveau mot decouvert sur "+ site);
    }
    
    public static void getMotsURL(String text) throws IOException
    {
        String mot="-";
        for(int i = 0; i<text.length();i++)
            if(text.charAt(i) !=' ')
                mot = mot + text.charAt(i);
            else
            {
                mot = mot.toLowerCase();                    
                synchronized(tabMot)
                {
                    //PrintWriter Temp = new PrintWriter(new BufferedWriter(new FileWriter("Base_de_donnee/tempMot.dat")));
                    
                    if(mot.length()>3 && tabMot.get(mot) == null)
                    {
                        tabMot.put(mot, (nurl + "-"));
                        //Temp.println(mot + "-" + nurl + "-");
                        nbreMot++;
                    }
                    else
                        if (mot.length()>3)
                        {
                            String oldindex = (String) tabMot.get(mot),temp = "-"+nurl+"-";
                            int l=oldindex.length()-2;
                            while(l>0 && oldindex.charAt(l) != '-')
                                l--;
                            if( !oldindex.substring(l,oldindex.length()).equals(temp) )
                            {
                                tabMot.put(mot, (oldindex + nurl + "-"));
                                //Temp.println(mot + oldindex + nurl + "-");
                            }
                        }
                    //Temp.close();
                }
                mot = "";
                
            }
    }
}
