import java.net.*;
import java.io.*;
import java.util.*;

public class Nomade extends Thread
{
    static String mot;
    static Hashtable taburl,tabMot, tabindurl;
    static PrintWriter s;
    static int nbreurl;
    
    public Nomade(String m, Hashtable TU, Hashtable TM, Hashtable TI)
    {
        mot = m;
        taburl = TU;
        tabMot = TM;
        tabindurl = TI;
        try
        {
            s =new PrintWriter(new BufferedWriter(new FileWriter("Base_de_donnee/Nomade.dat")));
        }
        catch(IOException IO)
        {
            System.out.println("Erreur d'ouverture du fichier");
        }
    }
    
    public static void Table(String url)
    {
        URL adresse;
        try
        {
            adresse = new URL(url);
            synchronized(taburl)
            {
                Integer n = (Integer)taburl.get(adresse);
                if (n == null)
                {
                    taburl.put(adresse, new Integer(nbreurl++));
                    tabindurl.put((tabindurl.size()+""), url);
                    System.out.println("Nomade new   : "+url);
                    s.println(url);
                }
                else System.out.println("Nomade old   : "+url);
            }
        }
        catch(MalformedURLException m)
        {
            System.out.println("Erreur URL sur Nomade: "+url);
        }
    }
    
    public void run()
    {
        int cpt=0;
        URL url;
        try
        {
            url = new URL("http://rechercher.nomade.tiscali.fr/recherche.asp?src=toolbar&MT="+mot+"&s="+mot+"&opt=0&x=29&y=8");
            BufferedReader in;
            try
            {
                in = new BufferedReader(new InputStreamReader(url.openStream()));
                String ligne,sep="</a></FONT>";
                int l,Ls=sep.length();
                while ((ligne = in.readLine()) != null)
                {
                    String http="";
                    l=ligne.length();
                    if(l>21 && ligne.substring(l-Ls,l).equals(sep))
                    {
                        boolean ok= false;
                        int i=l-Ls;
                        while(!ok)
                        {
                            if(ligne.charAt(i)!='>')
                                i--;
                            else ok=true;
                        }
                        if(ok)
                            http = ligne.substring(i+1,l-Ls);
                        Table(http);
                        URL u =new URL(http);
                        cpt++;
                    }
                }
                in.close();
                }
                catch(IOException IO)
                {
                    System.out.println("Ouverture page impossible");
                }
            }
        catch(MalformedURLException m)
        {
            System.out.print("Adresse URL incorrect");
        }
        s.close();
    }
}
