import java.util.Hashtable;
import java.net.*;
import java.io.*;

public class Yahoo extends Thread
{
    
    static String mot;
    static Hashtable taburl, tabMot, tabindurl;
    static PrintWriter s;
    public Yahoo(String m, Hashtable TU, Hashtable TM, Hashtable TI )
    {
        mot = m;
        taburl = TU;
        tabMot = TM;
        tabindurl = TI;
        try
        {
            s =new PrintWriter(new BufferedWriter(new FileWriter("Base_de_donnee/Yahoo.dat")));
        }
        catch(IOException IO)
        {
            System.out.println("erreur d'ouverture du fichier");
        }
    }
    
    public static void Table(String url)
    {
        URL adresse;
        try
        {
            adresse = new URL(url);
            synchronized(taburl)
            {
                Integer n = (Integer)taburl.get(adresse);
                if (n == null)
                {
                    taburl.put(adresse, new Integer(taburl.size()));
                    tabindurl.put((tabindurl.size()+""), url);
                    System.out.println("Yahoo new    : "+url);
                    s.println(url);
                }
                else System.out.println("Yahoo old    : "+url);
            }
        }
        catch(MalformedURLException m)
        {
            System.out.println("Erreur URL sur Yahoo: "+url);
        }
        
    }
    
    public void run()
    {
        BufferedReader in;
        try
        {
            URL url = new URL("http://fr.search.yahoo.com/search?fr=fp-tab-web-t-1&ei=ISO-8859-1&p="+mot+"&meta=vc%3D");
            try
            {
                in = new BufferedReader(new InputStreamReader(url.openStream()));
                String ligne;
                while ((ligne = in.readLine()) != null)
                {
                    String http="";
                    int p = ligne.length();
                    if(p > 10 && ligne.substring(p-4,p).equals("/em>"))
                    {
                        boolean ok= false;
                        int i=p-6;
                        while(!ok)
                        {
                            if(!ligne.substring(i,i+3).equals("<em"))
                                i--;
                            else ok=true;
                        }
                        while(ok)
                        {
                            if(ligne.charAt(i)!='>')
                                i++;
                            else ok=false;
                        }
                        for(int j=i+1;j<p-5;j++)
                            if(ligne.charAt(j)!='<')
                            {
                            http = http + ligne.charAt(j);
                            }
                            else 
                            {
                                while(ligne.charAt(j) != '>' && j<p-6)
                                    j++;
                            }
                        Table("http://"+http);
                    }
                }
            in.close();
            }
            catch(IOException IO)
            {
                System.out.println("Ouverture page impossible");
            }
            
        }
        catch(MalformedURLException m)
        {
            System.out.print("Adresse URL incorrect");
        }
        s.close();
    }
}
